# NOTE: this is a Linux-specific package, don't use the embedded
# viewer on non-Linux platforms.
%define name	nspluginwrapper
%define version	1.4.4
#define svndate	20061227
%define rel 0
%define subrel 1
%define release	%mkrel %{?svndate:0.%{svndate}.}%{rel}
%define _provides_exceptions xpcom
# list of plugins to be wrapped by default ex: libflashplayer,nppdf
%define nspw_plugins flashplayer,nppdf,rpnp,nphelix

# define 32-bit arch of multiarch platforms
%define arch_32 %{nil}
%ifarch x86_64
%define arch_32 i386
%endif
%ifarch ppc64
%define arch_32 ppc
%endif
%ifarch sparc64
%define arch_32 sparc
%endif

# define to build a biarch package
%define build_biarch		0
%if "%{_arch}:%{arch_32}" == "x86_64:i386"
%define build_biarch		1
%endif
%if "%{_arch}:%{arch_32}" == "ppc64:ppc"
%define build_biarch		1
%endif
%{expand: %{?_with_biarch:	%%global build_biarch 1}}
%{expand: %{?_without_biarch:	%%global build_biarch 0}}

# define target architecture of plugins we want to support
%define target_arch i386
%ifarch ppc64
%define target_arch ppc
%endif

# define target operating system of plugins we want to support
%define target_os linux

# define nspluginswrapper libdir (invariant, including libdir)
%define pkglibdir %{_prefix}/lib/%{name}

# define mozilla plugin dir
%define plugindir %{_libdir}/mozilla/plugins

Summary:	A compatibility layer for Netscape 4 plugins
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2+
Group:		Networking/WWW
# http://www.redhat.com/archives/nspluginwrapper-devel-list/2011-April/msg00006.html
URL:		https://github.com/davidben/nspluginwrapper
Source0:	http://web.mit.edu/davidben/Public/nspluginwrapper/%{name}-%{version}%{?svndate:-%{svndate}}.tar.gz
Source1:	nspluginwrapper.filter
Source2:	nspluginwrapper.script
Source3:	update-nspluginwrapper
Patch0:		nspluginwrapper-enable-v4l1compat.patch
BuildRequires:	curl-devel
BuildRequires:	gtk+2-devel
BuildRequires:	libxt-devel
BuildRequires:	libstdc++-static-devel
Provides:	%{name}-%{_arch} = %{version}-%release
Requires(post):	 %{name}-%{target_arch} = %{version}-%{release}
Requires(preun): %{name}-%{target_arch} = %{version}-%{release}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
ExcludeArch:	%mips %arm

%description
nspluginwrapper makes it possible to use Netscape 4 compatible plugins
compiled for %{target_os}/%{target_arch} into Mozilla for another architecture, e.g. x86_64.

This package consists in:
  * npviewer: the plugin viewer
  * npwrapper.so: the browser-side plugin
  * nspluginwrapper: a tool to manage plugins installation and update

%if %{build_biarch}
%package %{target_arch}
Summary:	A viewer for %{target_os}/%{target_arch} compiled Netscape 4 plugins
Group:		Networking/WWW
%if "%{target_arch}" == "i386"
Requires:	linux32
# Flash 10 now requires 32 bit libcurl, libnss3.so 
# but Adobe's RPM package does not require them...
# http://blogs.adobe.com/penguin.swf/2008/08/curl_tradeoffs.html
Suggests:       libcurl.so.4
Suggests:	libnss3.so
%endif

%description %{target_arch}
nspluginwrapper makes it possible to use Netscape 4 compatible plugins
compiled for %{target_os}/%{target_arch} into Mozilla for another architecture, e.g. x86_64.

This package consists in:
  * npviewer: the plugin viewer
  * npwrapper.so: the browser-side plugin
  * nspluginwrapper: a tool to manage plugins installation and update

This package provides the npviewer program for %{target_os}/%{target_arch}.
%endif

%prep

%setup -q
%patch0 -p1 -b .enable-v4l1compat

%build
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"

%if %{build_biarch}
enable_biarch="--enable-biarch"
%else
enable_biarch="--disable-biarch"
%endif

mkdir objs
pushd objs
../configure \
    --prefix=%{_prefix} \
    --target-cpu=%{target_arch} \
    --enable-viewer \
    $biarch

# XXX configure option
echo "DONT_STRIP = yes" >> config-host.mak
%make
popd

%install
rm -rf $RPM_BUILD_ROOT

make -C objs install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{plugindir}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/nspluginwrapper

touch $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/nspluginwrapper

ln -s %{pkglibdir}/%{_arch}/%{_os}/npwrapper.so $RPM_BUILD_ROOT%{plugindir}/npwrapper.so

install -d -m 0755 %buildroot%{_var}/lib/rpm/filetriggers
install -m 0644 %{SOURCE1} %buildroot%{_var}/lib/rpm/filetriggers
install -m 0755 %{SOURCE2} %buildroot%{_var}/lib/rpm/filetriggers
install -m 0755 %{SOURCE3} %buildroot%{_sbindir}

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 = 1 ]; then
  %{_bindir}/%{name} -v -a -i
else
  %{_bindir}/%{name} -v -a -u
  %if %{mdkversion} >= 200810
    if [ -f /usr/lib/mozilla/plugins/libflashplayer.so ] && [ ! -f %{plugindir}/npwrapper.libflashplayer.so ]; then
      %{_bindir}/%{name} -v -i /usr/lib/mozilla/plugins/libflashplayer.so
    else
      if [ -f /usr/lib/flash-plugin/libflashplayer.so ] && [ ! -f %{plugindir}/npwrapper.libflashplayer.so ]; then
        %{_bindir}/%{name} -v -i /usr/lib/flash-plugin/libflashplayer.so
      fi
    fi
  %endif
fi
if [ ! -f %{_sysconfdir}/sysconfig/nspluginwrapper ]; then
    cat > %{_sysconfdir}/sysconfig/nspluginwrapper <<EOF
USE_NSPLUGINWRAPPER=yes
MDV_PLUGINS="%{nspw_plugins}"
USER_PLUGINS=""
EOF
else
    sed -i "s/MDV_PLUGINS=.*/MDV_PLUGINS=\"%{nspw_plugins}\"/" \
        %{_sysconfdir}/sysconfig/nspluginwrapper
fi

%preun
if [ $1 = 0 ]; then
  %{_bindir}/%{name} -v -a -r
fi

# Flash Player
%triggerin -- FlashPlayer < 9.0.115.0
if [ -f %{plugindir}/npwrapper.libflashplayer.so ]; then
  %{_bindir}/%{name} -v -u %{plugindir}/npwrapper.libflashplayer.so
else
  %{_bindir}/%{name} -v -i /usr/lib/mozilla/plugins/libflashplayer.so
fi

%triggerpostun -- FlashPlayer < 9.0.115.0
if [ ! -f /usr/lib/mozilla/plugins/libflashplayer.so ]; then
  %{_bindir}/%{name} -v -r %{plugindir}/npwrapper.libflashplayer.so
fi

%triggerin -- FlashPlayer-plugin
if [ -f %{plugindir}/npwrapper.libflashplayer.so ]; then
  %{_bindir}/%{name} -v -u %{plugindir}/npwrapper.libflashplayer.so
else
  %{_bindir}/%{name} -v -i /usr/lib/mozilla/plugins/libflashplayer.so
fi

%triggerpostun -- FlashPlayer-plugin
if [ ! -f /usr/lib/mozilla/plugins/libflashplayer.so ]; then
  %{_bindir}/%{name} -v -r %{plugindir}/npwrapper.libflashplayer.so
fi


%triggerin -- flash-plugin
if [ -f %{plugindir}/npwrapper.libflashplayer.so ]; then
  %{_bindir}/%{name} -v -u %{plugindir}/npwrapper.libflashplayer.so
else
  %{_bindir}/%{name} -v -i /usr/lib/flash-plugin/libflashplayer.so
fi

%triggerpostun -- flash-plugin
if [ ! -f /usr/lib/flash-plugin/libflashplayer.so ]; then
  %{_bindir}/%{name} -v -r %{plugindir}/npwrapper.libflashplayer.so
fi

# Acrobat Reader
%triggerin -- acroread5-nppdf, acroread-nppdf
if [ -f %{plugindir}/npwrapper.nppdf.so ]; then
  %{_bindir}/%{name} -v -u %{plugindir}/npwrapper.nppdf.so
else
  %{_bindir}/%{name} -v -i /usr/lib/mozilla/plugins/nppdf.so
fi

%triggerpostun -- acroread5-nppdf, acroread-nppdf
if [ ! -f /usr/lib/mozilla/plugins/nppdf.so ]; then
  %{_bindir}/%{name} -v -r %{plugindir}/npwrapper.nppdf.so
fi

# Real Player 8
%triggerin -- RealPlayer-rpnp < 10
if [ -f %{plugindir}/npwrapper.rpnp.so ]; then
  %{_bindir}/%{name} -v -u %{plugindir}/npwrapper.rpnp.so
else
  %{_bindir}/%{name} -v -i /usr/lib/mozilla/plugins/rpnp.so
fi

%triggerpostun -- RealPlayer-rpnp < 10
if [ ! -f /usr/lib/mozilla/plugins/rpnp.so ]; then
  %{_bindir}/%{name} -v -r %{plugindir}/npwrapper.rpnp.so
fi

# Real Player 10
%triggerin -- RealPlayer-rpnp >= 10
if [ -f %{plugindir}/npwrapper.nphelix.so ]; then
  %{_bindir}/%{name} -v -u %{plugindir}/npwrapper.nphelix.so
else
  %{_bindir}/%{name} -v -i /usr/lib/mozilla/plugins/nphelix.so
fi

%triggerpostun -- RealPlayer-rpnp >= 10
if [ ! -f /usr/lib/mozilla/plugins/nphelix.so ]; then
  %{_bindir}/%{name} -v -r %{plugindir}/npwrapper.nphelix.so
fi

%files
%defattr(-,root,root)
%doc README NEWS
%{_bindir}/%{name}
%{_bindir}/nspluginplayer
%{_sbindir}/update-nspluginwrapper
%ghost %{_sysconfdir}/sysconfig/nspluginwrapper
%{plugindir}/npwrapper.so
%dir %{pkglibdir}
%dir %{pkglibdir}/noarch
%{pkglibdir}/noarch/npviewer.sh
%dir %{pkglibdir}/%{_arch}
%dir %{pkglibdir}/%{_arch}/%{_os}
%{pkglibdir}/%{_arch}/%{_os}/npconfig
%if ! %{build_biarch}
%{pkglibdir}/%{_arch}/%{_os}/npviewer
%{pkglibdir}/%{_arch}/%{_os}/npviewer.bin
#%{pkglibdir}/%{_arch}/%{_os}/libxpcom.so
%{pkglibdir}/%{_arch}/%{_os}/libnoxshm.so
%endif
%{pkglibdir}/%{_arch}/%{_os}/npplayer
%{pkglibdir}/%{_arch}/%{_os}/npwrapper.so
%{_var}/lib/rpm/filetriggers/nspluginwrapper.*

%if %{build_biarch}
%files %{target_arch}
%defattr(-,root,root)
%dir %{pkglibdir}/%{target_arch}
%dir %{pkglibdir}/%{target_arch}/%{target_os}
%{pkglibdir}/%{target_arch}/%{target_os}/npviewer
%{pkglibdir}/%{target_arch}/%{target_os}/npviewer.bin
#%{pkglibdir}/%{target_arch}/%{target_os}/libxpcom.so
%{pkglibdir}/%{target_arch}/%{target_os}/libnoxshm.so
%endif


%changelog
* Sat Oct 01 2011 Oden Eriksson <oeriksson@mandriva.com> 1.4.4-0.1mdv2010.2
- built for updates

* Tue Sep 06 2011 Oden Eriksson <oeriksson@mandriva.com> 1.4.4-1mdv2012.0
+ Revision: 698480
- 1.4.4

* Tue Jun 21 2011 Oden Eriksson <oeriksson@mandriva.com> 1.4.2-1
+ Revision: 686502
- 1.4.2

* Mon May 16 2011 Oden Eriksson <oeriksson@mandriva.com> 1.4.0-1
+ Revision: 675104
- 1.4.0

* Sun May 15 2011 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-0
+ Revision: 674884
- 1.3.2
- drop redundant patches

* Sun May 15 2011 Funda Wang <fwang@mandriva.org> 1.3.0-8
+ Revision: 674857
- br static

  + Oden Eriksson <oeriksson@mandriva.com>
    - attempt to fix the build
    - mass rebuild

* Wed Nov 03 2010 Götz Waschk <waschk@mandriva.org> 1.3.0-7mdv2011.0
+ Revision: 593023
- fix build with gcc 4.5 (spturtle)
- fix provides

* Tue Mar 30 2010 Pascal Terjan <pterjan@mandriva.org> 1.3.0-5mdv2010.1
+ Revision: 529690
- Have __sprintf_chk to do its job (except for the check)

* Tue Mar 30 2010 Pascal Terjan <pterjan@mandriva.org> 1.3.0-4mdv2010.1
+ Revision: 529679
- Define __stack_chk_fail_local and __sprintf_chk as they are needed by statically linked libsupc++

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuilt for 2010.1

  + Olivier Blin <blino@mandriva.org>
    - do not build on mips & arm (from Arnaud Patard)

* Sat May 02 2009 Frederik Himpe <fhimpe@mandriva.org> 1.3.0-1mdv2010.0
+ Revision: 370394
- Update to new version 1.3.0
- Remove patch for performance imporvements implemented upstream

* Fri Jan 02 2009 Frederik Himpe <fhimpe@mandriva.org> 1.2.2-1mdv2009.1
+ Revision: 323359
- Update to new version 1.2.2

* Sun Dec 28 2008 Frederic Crozat <fcrozat@mandriva.com> 1.2.0-1mdv2009.1
+ Revision: 320703
- Release 1.2.0
- Remove patch11 (merged upstream)

* Thu Dec 18 2008 Frederic Crozat <fcrozat@mandriva.com> 1.1.10-1mdv2009.1
+ Revision: 315498
- Release 1.1.10
- Remove patch11 (merged upstream)
- Patch11 (SVN): mimic FF3 behaviour in plugin release

* Wed Dec 03 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.8-1mdv2009.1
+ Revision: 309816
- Update to new version 1.1.8
- Resync Fedora patches

* Tue Oct 28 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.2-3mdv2009.1
+ Revision: 298056
- Add fix for assertion with Flash 10

* Sun Oct 26 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.2-2mdv2009.1
+ Revision: 297494
- Use event patch instead of sleep patch, like Fedora is doing. It
  should improve stability with Flash 10
- Suggest libnss3.so for Flash 10 (bug #45322)

* Thu Oct 16 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.2-1mdv2009.1
+ Revision: 294449
- Update to new version 1.1.2
- Remove 2 patches integrated upstream
- Add suggests: libcurl.so.4 on nspluginwrapper-i386, because Flash
  10 now requires this

* Wed Oct 15 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.0-8mdv2009.1
+ Revision: 294083
- Sync with Fedora patches:
  * Updated visual id fix for windowless crash with Flash 10 and Firefox 3
    (use the patch which is integrated in upstream svn now)
  * Concurrent rpc_method_invoke() patch (fixes some Flash crashes)

* Wed Sep 17 2008 Tiago Salem <salem@mandriva.com.br> 1.1.0-7mdv2009.0
+ Revision: 285564
- add LD_PRELOAD to v4l1compat.so.0
- bump release

* Thu Sep 04 2008 Tiago Salem <salem@mandriva.com.br> 1.1.0-6mdv2009.0
+ Revision: 280849
- add rpm filetrigger to handle new plugins
- add file to configure nspluginwrapper behavior
- add update-nspluginwrapper script to manage nspluginwrapper
- bump release

* Sat Aug 16 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.0-5mdv2009.0
+ Revision: 272764
- Extend postin script and triggers to deal with flash-plugin RPM
  downloaded from the Adobe site

* Thu Aug 14 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.0-4mdv2009.0
+ Revision: 272194
- Don't provide libxpcom.so (bug #42790)

* Wed Aug 06 2008 Frederik Himpe <fhimpe@mandriva.org> 1.1.0-3mdv2009.0
+ Revision: 264846
- Add Fedora patch fixing RH crasher bug #456432

* Mon Jul 21 2008 Olivier Blin <blino@mandriva.org> 1.1.0-2mdv2009.0
+ Revision: 239260
- fix filelist for x86_64
- buildrequire curl-devel (for the standalone player)
- add selected fixes from the Fedora package
- package nspluginplayer
- package new npplayer and libnoxshm plugins
- 1.1.0

* Mon Jun 30 2008 Oden Eriksson <oeriksson@mandriva.com> 1.0.0-1mdv2009.0
+ Revision: 230202
- 1.0.0
- drop upstream implemented patches

* Thu Jun 26 2008 Oden Eriksson <oeriksson@mandriva.com> 0.9.91.5-4mdv2009.0
+ Revision: 229267
- add triggers for FlashPlayer-plugin (#39969) (Luc Menut)
- modify triggers for FlashPlayer consequently (FlashPlayer < 9.0.115.0) (Luc Menut)

* Tue Jun 24 2008 Tiago Salem <salem@mandriva.com.br> 0.9.91.5-3mdv2009.0
+ Revision: 228762
- fix focus issue in Adobe Acrobat 8

* Sun Feb 03 2008 Frederik Himpe <fhimpe@mandriva.org> 0.9.91.5-2mdv2008.1
+ Revision: 161581
- Add part of Debian's patch to patch0 in order to make it compile on x86_64
- Add patch0 from Fedora (and also included in Debian, Ubuntu and upstream) which fixes Flash 9.0.115 on SMP systems (http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=458584 and https://bugzilla.redhat.com/show_bug.cgi?id=360891)

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Mon Aug 27 2007 Funda Wang <fwang@mandriva.org> 0.9.91.5-1mdv2008.0
+ Revision: 71706
- New version 0.9.91.5

* Fri Jun 29 2007 Funda Wang <fwang@mandriva.org> 0.9.91.4-1mdv2008.0
+ Revision: 45625
- New verison
  Patch 0,1 merged upstream

